//#####################################################################
//Additional dependencies
//#####################################################################
var thisScript = document.scripts[document.scripts.length-1];
var srcPath = thisScript.src.substring(0,thisScript.src.length - 'iconsole.js'.length);
document.write('<script src="' + srcPath + 'PM.js"><' + '/script>');
document.write('<script src="' + srcPath + 'commsWrapper.js"><' + '/script>');

//#####################################################################
//The i console interface
//#####################################################################
var iConsole = {

    //#####################################################################
    //game support
    //#####################################################################
    game: {

        loadProgress: function (data) {
            return CommsWrapper.postMessage('gameLoadProgress', data);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.gameLoadProgress, data);
        },

        loaded: function (data) {
            return CommsWrapper.postMessage('gameLoaded', data);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.gameLoadComplete, data);
        },

        ready: function (data) {
            if (!data || !data.soundOnOff) {
                // If the game doesn't explictly support programatic muting of the audio, we have to polyfill this
                iConsole.game.internal.prepareMutableAudio();
            } else {
                iConsole.game.internal.gameHandlesMute = true;
                window.AudioContext = iConsole.game.internal.oldAudioContext;
            }
            return CommsWrapper.postMessage('gameReady', data);
            //var actualPromise = iConsole.internal.parentConsole.gameReady(data);
            //return new PromiseWrapper( actualPromise );
        },

        getLevelData: function (data) {
            return CommsWrapper.postMessage('getLevelData', data);
            //Future cleanup - do any games actually use this API ?
            //return new PromiseWrapper( iConsole.internal.parentConsole.getLevelData(data) );
        },

        setLevelData: function (data) {
            return CommsWrapper.postMessage('setLevelData', data);
            //Future cleanup - do any games actually use this API ?
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.setLevelData, data);
        },

        getGameData: function (data) {
            return CommsWrapper.postMessage('getGameData', data);
            //return new PromiseWrapper( iConsole.internal.parentConsole.getGameData() );
        },

        setGameData: function (data) {
            return CommsWrapper.postMessage('setGameData', data);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.setGameData, data);
        },

        postHighScore: function (data) {
            return CommsWrapper.postMessage('postHighScore', data);
            //return new PromiseWrapper( iConsole.internal.parentConsole.postScore(data) );
        },

        gameOver: function () {
            return CommsWrapper.postMessage('gameOver', undefined);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.gameOver, undefined);
        },

        levelStarted: function (info) {
            var levelData;
            var advertHidden = false;
            var fnCall;
            var context;
            var triggered = false;
            var deferred = {
                result: function(fnToCall, contX) {
                    fnCall = fnToCall;
                    context = contX;
                    this.trigger();
                },
                trigger: function() {
                    if (levelData && advertHidden && fnCall && !triggered) {
                        triggered = true;
                        fnCall.apply(context, [levelData]);
                    }
                }
            };
            iConsole.game.getLevelData(info).result(function(data) {
                levelData = data;
                deferred.trigger();
            });
            iConsole.ads.show({ type: 'levelStart', level: info.level }).result(function () {
                advertHidden = true;
                deferred.trigger();
            });
            return deferred;
        },

        levelFinished: function (info) {
            //Future cleanup - would be better if all games used this without expecting an empty promise return value.
            //Future cleanup - do any games actually use this API ?
            //Future cleanup - This is bad... the game should be sending the game data, not the console. Only putting this in here to ensure backwards compatibility
            iConsole.game.setGameData(info.data);
            return iConsole.game.setLevelData(info);
        },

        onEvent: function (eventType, callbackFunction) {
            if (iConsole.game.internal.callbacks[eventType] === undefined) {
                iConsole.game.internal.callbacks[eventType] = [];
            }
            var callbacksForEventType = iConsole.game.internal.callbacks[eventType];
            if (iConsole.internal.inArray(callbackFunction, callbacksForEventType) === -1) {
                callbacksForEventType.push(callbackFunction);
            }
        },

        offEvent: function (eventType, callbackFunction) {
            if (iConsole.game.internal.callbacks[eventType] !== undefined) {
                var callbacksForEventType = iConsole.game.internal.callbacks[eventType];
                var position = iConsole.internal.inArray(callbackFunction, callbacksForEventType);
                if (position !== -1) {
                    callbacksForEventType.splice(position, 1);
                }
            }
        },

        getWidth: function() {
            return window.innerWidth;
        },

        getHeight: function() {
            return window.innerHeight;
        },

        setHomeWidgetLabel: function(label) {
            return CommsWrapper.postMessage('setHomeWidgetLabel', label);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.setHomeWidgetLabel, label );
        },

        hideConsoleWindow: function() {
            return CommsWrapper.postMessage('hideConsoleWindow', undefined);
            //return iConsole.internal.callAndReturnEmptyPromise( iConsole.internal.parentConsole.hideConsoleWindow, undefined );
        },
        requestLocale: function(locales) {
            return CommsWrapper.postMessage('requestLocale', { locales: locales } );
        },

        internal: {

            callbacks: [],

            // function is called via the Commswrapper callback which is dynamically injected at the bottom of this script
            handleEventRequest: function (request) {
                var type = request.data.type;
                iConsole.game.internal.handleEvent(type, new Event(type));
                request.result();
            },
            handleEvent: function (eventType, event) {
                if (eventType !== undefined && event !== undefined) {
                    event.stopPropagationSet = false;
                    event.stopPropagation = function() {this.stopPropagationSet = true;};
                    if (iConsole.game.internal.callbacks[eventType] !== undefined) {
                        var callbacksForEventType = iConsole.game.internal.callbacks[eventType];
                        var i = 0;
                        while (i < callbacksForEventType.length && event.stopPropagationSet === false) {
                            callbacksForEventType[i](event);
                            i++;
                        }
                    }
                }
            },
            
            // Does the game handle calls to soundOn/soundOff events
            gameHandlesMute: false,
            // Any audio objects the game creates via either document.createElement or new Audio(). We track these so that
            // we can mute them if we need to
            audioObjects: [],
            // Any audio objects that we muted when we went to mute, so we know which ones to un-mute
            mutedObjects: [],
            // Any gainNode objects we created. These occur when using WebAudio, and something attempts to attach to
            // the AudioContext().destination... we inject a gainNode in the middle to allow us to dynamically mute that
            // audio
            gainObjects: [],
            // The document.createElement function. We override this function with our own function, but we need a handle
            // on the original
            oldDocumentCreateElement: document.createElement,
            // The original Audio object on the window. We override this function with our own function, but we need a
            // handle on the original
            oldAudio: window.Audio,
            // The original AudioContext object. We override this function with our own function, but we need a handle on
            // the original
            oldAudioContext: window.AudioContext || window.webkitAudioContext,

            /**
             * This function will override the non webAudio audio platform with our own functions to track creation of
             * DOM elements... so that any Audio tags are tracked 
             */
            prepareMutableAudio: function() {
                var internal = iConsole.game.internal;
                iConsole.game.onEvent('soundOn', internal.soundOn);
                iConsole.game.onEvent('soundOff', internal.soundOff);
                document.createElement = internal.documentCreateElement;
                window.Audio = internal.newAudio;
            },

            /**
             * replaces the document.createElement function, but if you have requested an audio element, we will track
             * this so that we can mute this if required. 
             */
            documentCreateElement: function(name) {
                var internal = iConsole.game.internal;
                var returnable = internal.oldDocumentCreateElement.call(document, name);
                if (name.toLowerCase === 'audio') {
                    internal.audioObjects.push(returnable);
                }
                return returnable;
            },
            /**
             * replaces window.Audio, and is called like new Audio(). This tracks the creation of the audio DOM object
             * so that we can mute it if required 
             */
            newAudio: function(src) {
                var internal = iConsole.game.internal;
                var audio = new internal.oldAudio(src);
                internal.audioObjects.push(audio);
                return audio;
            },
            /**
             * replaces AudioContext. This audio context will offer all the same functions of the WebAudio API, but any
             * elements you try to create are tracked. If you attempt to connect one of those elements to the destination
             * then an intermediate gainNode is injected between that and the destination, that allows us to control the
             * volume, and mute it when required 
             */
            newAudioContext: function() {
                var internal = iConsole.game.internal;
                var context = new internal.oldAudioContext();
                var realCreateGain = context.createGain;
                //internal.gainObject = context.createGain();
                //internal.gainObject.connect(context.destination);
                var functions = [
                    'createAnalyser',
                    'createBiquadFilter',
                    'createBufferSource',
                    'createChannelMerger',
                    'createChannelSplitter',
                    'createConvolver',
                    'createDelay',
                    'createDynamicsCompressor',
                    'createGain',
                    'createMediaElementSource',
                    'createMediaStreamSource',
                    'createOscillator',
                    'createPanner',
                    'createPeriodicWave',
                    'createScriptProcessor',
                    'createStereoPanner',
                    'createWaveShaper'
                ];
                for (var i = 0; i < functions.length; i++) {
                    (function (context, name) {
                        var oldFunction = context[name];
                        context[name] = function () {
                            var functionArguments = Array.prototype.slice.call(arguments);
                            var audioNode = oldFunction.apply(context, functionArguments);
                            var oldConnect = audioNode.connect;
                            audioNode.connect = function (node) {
                                if (node === context.destination) {
                                    var gainNode = realCreateGain.call(context);
                                    oldConnect.call(audioNode, gainNode);
                                    gainNode.connect(node);
                                    internal.gainObjects.push(gainNode);
                                } else {
                                    oldConnect.call(audioNode, node);
                                }

                            };
                            return audioNode;
                        }

                    })(context, functions[i]);
                }
                return context;
            },

            /**
             * Un Mute the sound based upon whether we are using DOM audio or WebAudio 
             */
            soundOn: function() {
                var internal = iConsole.game.internal;
                if (!internal.gameHandlesMute) {
                    for (var i = 0; i < internal.mutedObjects.length; i++) {
                        var audio = internal.mutedObjects[i];
                        audio.play();
                    }
                    if (internal.gainObjects.length > 0) {
                        for (var i = 0; i < internal.gainObjects.length; i++) {
                            internal.gainObjects[i].gain.value = 1;
                        }
                    }
                    internal.mutedObjects = [];
                }
            },
            /**
             * Mute the sound based upon whether we are using DOM audio or WebAudio
             */
            soundOff: function() {
                var internal = iConsole.game.internal;
                if (!internal.gameHandlesMute) {
                    for (var i = 0; i < internal.audioObjects.length; i++) {
                        var audio = internal.audioObjects[i];
                        if (!audio.paused || audio.currentTime) {
                            audio.pause();
                            internal.mutedObjects.push(audio);
                        }
                    }
                    if (internal.gainObjects.length > 0) {
                        for (var i = 0; i < internal.gainObjects.length; i++) {
                            internal.gainObjects[i].gain.value = 0;
                        }
                    }
                }
            }

        }
    },



    //#####################################################################
    //periodical support
    //#####################################################################
    periodical: {
        internal: {
            url: '',
            mappings: {},
            periods: []
        },

        getData:function(periodsBack){
            if (!periodsBack || typeof periodsBack !== 'number' || periodsBack !== Math.floor(periodsBack)) { periodsBack = 0; }
            var callback = null;
            var dataReceieved = null;
            // A function that will be returned to the caller
            var resultFunction = function(callbackFunction) {
                callback = callbackFunction;
                if (dataReceieved) {
                    // call the callback
                    callback(dataReceieved.data, dataReceieved.period);
                    // clear this storage of the data to prevent against unnecessary memory usage
                    dataReceieved = null;
                }
            };
            CommsWrapper.postMessage('periodicalGetData', {periodsBack: periodsBack}).result(function(data){
                dataReceieved = data;
                if (callback) {
                    resultFunction(callback);
                }
            });
            //Future cleanup - would be better if we just returned a promise which calls their resultFunction with an object { data: ... , period: ... }
            return { result: resultFunction };
        },

        getPeriods:function(){
            //dataReceived.periods
            return CommsWrapper.postMessage('periodicalGetPeriods', {});
            //return new PromiseWrapper( iConsole.internal.parentConsole.periodicalGetPeriods() );
        },

        getFileURI: function(uri) {
            if (iConsole.periodical.internal.mappings[uri]) {
                return iConsole.periodical.internal.mappings[uri]; 
            } else if (uri.indexOf('http://') === 0|| uri.indexOf('https://') === 0) {
                return uri;
            } else {
                return iConsole.periodical.internal.url + uri;
            }
        }

    },


    //#####################################################################
    //iap support
    //#####################################################################
    iap: {
        isSupported: function() {
            return iConsole.iap.internal.iapSupported;
        },

        purchase: function(sku) {
            var successFailureInterface = (function(){
                var successCallback = null;
                var failureCallback = null;
                //iConsole.internal.parentConsole.iapPurchase(sku).then(
                //    function() {
                //        if (successCallback) { failureCallback(sku); }
                //    },
                //    function() {
                //        if (failureCallback) { failureCallback(sku); }
                //    }
                //);

                var returnable = {
                    success: function(callback) {
                        successCallback = callback;
                        return returnable;
                    },
                    failure: function(callback) {
                        failureCallback = callback;
                        return returnable;
                    }
                };
                
                // Fail almost immediately
                setTimeout(failureCallback, 1);
                return returnable;
            })();
            return successFailureInterface;
        },

        isAnalyticsSupported: function() {
            return iConsole.iap.internal.analyticsSupported;
        },

        getConsoleProvider: function() {
            return iConsole.iap.internal.provider;
        },

        internal: {
            iapSupported: false,
            analyticsSupported: false,
            provider: ''
        }
    },


    //#####################################################################
    //advert support
    //#####################################################################
    ads: {
        midGameAdvertStartedCallbacks: [],
        midGameAdvertFinishedCallbacks: [],

        show:function(data){
            return CommsWrapper.postMessage('showAdvert', data);
            //return new PromiseWrapper( iConsole.internal.parentConsole.showAdvert(data) );
        },

        registerMidGameAdvertStartedListener: function(callbackFunctionToRegister, context) {
            //Future cleanup - do any games use this api ?
            iConsole.ads.midGameAdvertStartedCallbacks.push([callbackFunctionToRegister, context]);
        },

        registerMidGameAdvertFinishedListener: function(callbackFunctionToRegister, context) {
            //Future cleanup - do any games use this api ?
            iConsole.ads.midGameAdvertFinishedCallbacks.push([callbackFunctionToRegister,context]);
        },

        unregisterMidGameAdvertStartedListener: function(callbackFunctionToUnregister) {
            //Future cleanup - do any games use this api ?
            for (var i = 0; i < iConsole.ads.midGameAdvertStartedCallbacks.length; i++) {
                if (iConsole.ads.midGameAdvertStartedCallbacks[i][0] === callbackFunctionToUnregister) {
                    iConsole.ads.midGameAdvertStartedCallbacks = iConsole.ads.midGameAdvertStartedCallbacks.splice(i, 1);
                    i--;
                }
            }
        },

        unregisterMidGameAdvertFinishedListener: function(callbackFunctionToUnregister) {
            //Future cleanup - do any games use this api ?
            for (var i = 0; i < iConsole.ads.midGameAdvertFinishedCallbacks.length; i++) {
                if (iConsole.ads.midGameAdvertFinishedCallbacks[i][0] === callbackFunctionToUnregister) {
                    iConsole.ads.midGameAdvertFinishedCallbacks = iConsole.ads.midGameAdvertFinishedCallbacks.splice(i,1);
                    i--;
                }
            }
        },

        //"ads:midgame:start"
        consoleNotifyMidGameAdvertStarting: function(request) {
            //Future cleanup - do any games use this api ?
            for (var i = 0; i < iConsole.ads.midGameAdvertStartedCallbacks.length; i++) {
                var key = iConsole.ads.midGameAdvertStartedCallbacks[i];
                key[0].call(key[1], request);
            }
        },

        //"ads:midgame:finish"
        consoleNotifyMidGameAdvertFinished: function(request) {
            //Future cleanup - do any games use this api ?
            for (var i = 0; i < iConsole.ads.midGameAdvertFinishedCallbacks.length; i++) {
                var key = iConsole.ads.midGameAdvertFinishedCallbacks[i];
                key[0].call(key[1], request);
            }
        }

    },


    internal: {
        window: {},
        //parentConsole: null,
        //parentJquery: null,

        init: function(widnow)
        {
            //init the means to pass methods back and forth between parent and child
            //iConsole.internal.window = widnow;
            //iConsole.internal.parentConsole = widnow.Console;
            //iConsole.internal.parentJquery = widnow.$;
            //
            ////init any data from the parents provider
            //var parentProvider = widnow.Provider;
            //iConsole.iap.internal.provider = parentProvider.name;
            //iConsole.iap.internal.iapSupported = parentProvider.iapEnabled;
            //iConsole.iap.internal.analyticsSupported = parentProvider.iapAnalyticsEnabled;
        },

        inArray: function( elem, arr, i ) {
            return arr === null ? -1 : [].indexOf.call( arr, elem, i );
        }//,
        //
        //callAndReturnEmptyPromise: function( functionToCall, functionData ) {
        //    //Future cleanup - would be better if all games used this without expecting an empty promise return value.
        //    if ( functionData === undefined )
        //    {
        //        functionToCall();
        //    }
        //    else
        //    {
        //        functionToCall( functionData );
        //    }
        //    return new EmptyPromise( null );
        //}

    }

    //Future cleanup - consider using closure to return just the external interface we want.
};
iConsole.internal.init(window);
(function(){
    var consoleWrite = function(type, args) {
        try {
            CommsWrapper.postMessage('console', {
                type: type,
                args: JSON.parse(JSON.stringify(Array.prototype.slice.call(args)))
            });
        } catch (e) {
            CommsWrapper.postMessage('console', {
                type: type,
                args: ['Exception passing message to console']
            });
        }
    };
    console.debug = function() { consoleWrite('debug', arguments); };
    console.error = function() { consoleWrite('error', arguments); };
    console.log = function() { consoleWrite('log', arguments); };
    console.info = function() { consoleWrite('info', arguments); };
    console.warn = function() { consoleWrite('warn', arguments); };
})();
// Capture the audioContext prior to any game code running. We need this in order to inject a gainNode that will allow
// us to add muting capability;
window.AudioContext = iConsole.game.internal.oldAudioContext ? iConsole.game.internal.newAudioContext : undefined;
document.write('<script' + '>');
document.write('CommsWrapper.addCommandHandler(\'init\', function(data) {\
    data = data.data;\
    iConsole.iap.internal.provider = data.iap.provider;\
    iConsole.iap.internal.iapSupported = data.iap.supported;\
    iConsole.iap.internal.analyticsSupported = data.iap.analyticsSupported;\
    iConsole.periodical.internal = data.periodical;\
}); CommsWrapper.addCommandHandler(\'event\', iConsole.game.internal.handleEventRequest);');
document.write('</script'+ '>');