(function(){
    var writeID = 0;
    var writingInProgress = {};
    var saveProgress = function(game, callback) {
        var postDeletedFunction = function() {
            saveProgressInner(game, callback);
        };
        app.util.deleteFile(cordova.file.dataDirectory + 'progress/' + game + '.json', postDeletedFunction, postDeletedFunction);
    };
    var saveProgressInner = function(game, callback) {
        var usefulFailureFunction = function() {
            console.error(arguments);
            callback();
        };
        var gameProgress = writingInProgress[game];
        if (gameProgress) {
            var id = gameProgress.id;
            var progress = gameProgress.contents;
            resolveLocalFileSystemURL(cordova.file.dataDirectory, function(root) {
                root.getDirectory('progress', {create: true}, function(progressDir) {
                    progressDir.getFile(game + '.json', {create: true}, function(progressFile){
                        progressFile.createWriter(function(writer) {
                            if (writingInProgress[game ].id === id) {
                                var blob = new Blob([progress], {type:'text/plain'});
                                writer.write(blob);
                                // Let's verify that we've got valid JSON... occasionally this gets really screwed up
                                writer.onwriteend = function(){
                                    console.log('written progress');
                                    app.util.verifyJSON(cordova.file.dataDirectory + 'progress/' + game + '.json', callback,
                                        function(error, text) {
                                            console.log('Failed to save progress correctly, trying again');
                                            saveProgress(game, callback);
                                        });
                                    callback();
                                };
                                writer.onerror = function(err) {
                                    console.error(err);
                                    saveProgress(game, callback);
                                };
                            } else {
                                saveProgress(game, callback);
                            }
                        }, usefulFailureFunction);
                    }, usefulFailureFunction);
                }, usefulFailureFunction)
            }, usefulFailureFunction)
        } else {
            app.util.queueFunctionToRunAfterCurrentThread(callback);
        }
    };
    /* istanbul ignore next */
    window.app = window.app || {};
    window.app.util = {
        chainFunction: function ( chain, successFunction, failureFunction ) {
            successFunction = successFunction ? successFunction : app.util.emptyFunction;
            failureFunction = failureFunction ? failureFunction : app.util.error;
            var index = -1;
            var usefulFailureFunction = function(func, args) {
                var returnable = function() {
                    console.log(func);
                    console.log(args);
                    console.log(arguments);
                    failureFunction();
                };
                return returnable;
            };
            var returnFunction = function () {
                index = index + 1;
                if ( index < chain.length ) {
                    if ( index + 1 < chain.length && typeof chain[ index + 1 ] === 'object' && typeof chain[ index + 1 ].length === 'number' ) {
                        var func = chain[ index ];
                        index = index + 1;
                        var args = chain[ index ];
                        args.push( returnFunction );
                        args.push( usefulFailureFunction(func, args) );
                        func.apply( this, args );
                    } else {
                        chain[ index ]( returnFunction, usefulFailureFunction(chain[ index ], null) );
                    }
                } else {
                    successFunction();
                }
            };
            returnFunction();
        },
        executeAll: function ( chain, parallel, successFunction, failureFunction ) {
            if (parallel === -1) {
                parallel = chain.length;
            }
            if (cordova.platformId === 'ios') {
                // iOS has weird errors complaining that files exist when they clearly don't. The only thing that I
                // have been able to point to so far, is that we could be dirtying a shared variable (but I can't see
                // why a particular variable would be shared). So force the parallel to 1, i.e. it behaves as a chain.
                parallel = 1;
            }
            var self = this;
            var status = [];
            var failed = false;
            var completed = function(index) {
                var returnFunction = function() {
                    status[index] = true;
                    runNext();
                    var complete = true;
                    for (var i = 0; complete && i < status.length; i++) {
                        complete = status[i];
                    }
                    if (complete && !failed) {
                        successFunction();
                    }
                };
                return returnFunction;
            };
            var usefulFailureFunction = function(func, args) {
                var returnable = function() {
                    failed = true;
                    console.log(func);
                    console.log(args);
                    console.log(arguments);
                    failureFunction();
                };
                return returnable;
            };
            var runNext = function() {
                var func = funcs.shift();
                var localArgs = args.shift();
                if (func) {
                    func.apply(self, localArgs);
                }
            };
            
            var index = 0;
            var functionCount = 0;
            var funcs = [];
            var args = [];
            // Ensure we count all the functions and prepare the status objects first, as some of the functions may be
            // synchronous and not asynchronous.
            while (index < chain.length) {
                var func = chain[ index ];
                funcs.push( func );
                var localArgs = [];
                if ( index + 1 < chain.length && typeof chain[ index + 1 ] === 'object' && typeof chain[ index + 1 ].length === 'number' ) {
                    index = index + 1;
                    localArgs = chain[ index ];
                }
                localArgs.push( completed(functionCount) );
                localArgs.push( usefulFailureFunction( func, localArgs ) );
                args.push(localArgs);
                index = index + 1;
                functionCount = functionCount + 1;
                status.push(false);
            }
            // Run up to the parallel limit, the functions
            for (var i = 0; i < funcs.length && i < parallel; i++) {
                runNext();
            }
        },
        copyFile: function ( fromName, fromFile, toDirectory, success, failure ) {
            if (app.html && cordova.platformId === 'ios') {
                new FileTransfer().download(encodeURI(fromFile + fromName), toDirectory + fromName, success, failure);
            } else {
                resolveLocalFileSystemURL(fromFile + fromName, function (fromFileEntry) {
                    resolveLocalFileSystemURL(toDirectory, function (toDirectoryEntry) {
                        (function (callback) {
                            app.util.deleteFile(toDirectory + fromName, callback, callback);
                        })(function () {
                            fromFileEntry.copyTo(toDirectoryEntry, null, success, failure);
                        })
                    }, failure);
                }, failure);
            }
        },
        deleteFile: function( file, success, failure ) {
            resolveLocalFileSystemURL( file , function(fileHandle) {
                fileHandle.remove(success, failure);
            }, success);
        },
        deleteFolder: function( directory, success, failure) {
            resolveLocalFileSystemURL( directory, function(directoryHandle) {
                directoryHandle.removeRecursively(success, failure);
            }, success);
        },
        moveFile: function(file, directory, success, failure) {
            resolveLocalFileSystemURL(cordova.file.dataDirectory, function(root) {
                root.getDirectory(directory, {create: true}, function(directoryHandle) {
                    resolveLocalFileSystemURL(file, function(fileHandle){
                        fileHandle.moveTo(directoryHandle, undefined, success, failure);
                    }, failure);
                }, failure);
            }, failure);
        },
        writeObjectAsJSON: function(object, directory, fileName, success, failure){
            resolveLocalFileSystemURL(cordova.file.dataDirectory, function(root) {
                root.getDirectory(directory, {create: true}, function(directoryHandle) {
                    directoryHandle.getFile(fileName, {create: true}, function(fileHandle){
                        fileHandle.createWriter(function(writer) {
                            var blob = new Blob([JSON.stringify(object)], {type: 'text/plain'});
                            writer.write(blob);
                            writer.onwriteend = function() {
                                success(object);
                            };
                            writer.onerror = failure;
                        }, failure);
                    }, failure);
                }, failure);
            }, failure);
        },
        loadGameStateFromLS: function() {
            var gameStates = localStorage.getItem('gameStates');
            if (!gameStates) {
                gameStates = "{}";
            }
            // Remove any temporary state variables.
            gameStates = gameStates.replace(/"downloading":(true|false),?/g,'');
            gameStates = gameStates.replace(/,}/g,'}');
            app.gameStates = JSON.parse(gameStates);
            
            app.util.storeGameStateToLS();
        },
        storeGameStateToLS: function() {
            localStorage.setItem('gameStates', JSON.stringify(app.gameStates));
        },
        loadAppStateFromLS: function () {
            var appState = localStorage.getItem('appstate');
            if (!appState) {
                appState = '{"sitePrefix": ""}';
            }
            app.appState = JSON.parse(appState);
            app.util.storeAppStateToLS();
        },
        storeAppStateToLS: function () {
            localStorage.setItem('appstate', JSON.stringify(app.appState));
        },
        loadIndividualGameProgress: function(game, callback) {
            var file = cordova.file.dataDirectory + '/progress/' + game + '.json';
            resolveLocalFileSystemURL(file, function(progressFileEntry){
                progressFileEntry.file(function(progressFile){
                    var reader = new FileReader();
                    reader.onload = function(event) {
                        try {
                            console.log(this.result);
                            handlers.user = JSON.parse( this.result );
                        } catch(err) {
                            handlers.resetUser();
                        }
                        callback();
                    };
                    reader.readAsText(progressFile);
                });
            }, function() {
                handlers.resetUser();
                callback();
            });
        },
        saveIndividualGameProgress: function(game, progress, callback) {
            writingInProgress[game] = {
                id: writeID++,
                contents: JSON.stringify(progress)
            };
            saveProgress(game, callback);
        },
        isVersionNewer: function(current, test) {
            console.log('current - ' + current);
            console.log('test - ' + test);
            if (current) {
                if (test) {
                    var currentVersion = current.split('.');
                    var testVersion = test.split('.');
                    if (testVersion.length !== currentVersion.length) {
                        return false;
                    }
                    var equal = window.debug === true;
                    for (var i = 0; i < testVersion.length; i++) {
                        var partialTest = parseInt(testVersion[i]);
                        var partialCurrent = parseInt(currentVersion[i]);
                        if (partialTest > partialCurrent) {
                            return true;
                        }
                        if (equal && partialCurrent !== partialTest) {
                            equal = false;
                        }
                    }
                    return equal;
                } else {
                    return false;
                }
            } else {
                return true;
            }
        },
        swapSitePrefix: function() {
            if (app.appState.sitePrefix === '' || app.appState.sitePrefix === '2') {
                app.appState.sitePrefix = '1';
            } else {
                app.appState.sitePrefix = '2';
            }
            app.util.storeAppStateToLS();
            return app.appState.sitePrefix;
        },
        isGameCurrentlyPlaying: function() {
            var frameSrc = $('#mainframe').attr('src');
            return frameSrc !== undefined && frameSrc !== '' && frameSrc !== '/app/blank.html'
        },
        storeOrientationFromDetails: function(game, successFunction, failureFunction){
            $.ajax('/content/' + game + '/details.json').done(function(data){
                data = typeof data === 'string' ? JSON.parse(data) : data;
                window[game] = window[game] || {};
                window[game].orientation = data.orientation;
                successFunction();
            }).fail(failureFunction);
        },
        startServer: function(success, failure) {
            resolveLocalFileSystemURL(cordova.file.dataDirectory, function (root) {
                root.getDirectory('tmp', {create: true, exclusive: false}, function () {
                    root.getDirectory('content', {create: true, exclusive: false}, app.util.startServerOnceFoldersExist(success, failure),
                        function () {
                            console.log(arguments);
                        });
                }, function () {
                    console.log(arguments);
                });
            });
        },
        startServerOnceFoldersExist: function(success, failure) {
            var returnable = function() {
                cordova.plugins.CorHttpd.startServer({
                    'www_root': '',
                    'port': 8080,
                    'localhost_only': false,
                    'custom_paths': {
                        '/app/': cordova.file.dataDirectory.substring(7) + 'app/',
                        '/content/': cordova.file.dataDirectory.substring(7) + 'content/',
                        '/tmp/': cordova.file.dataDirectory.substring(7) + 'tmp/',
                        '/onlinegames/': app.gamesDomain + '/'
                    }
                }, success, failure);
            };
            return returnable;
        },
        verifyJSON: function(file, success, failure) {
            resolveLocalFileSystemURL(file, function(fileEntry){
                fileEntry.file(function(fileFile){
                    var reader = new FileReader();
                    reader.onload = function(event) {
                        try {
                            success(JSON.parse( reader.result ));
                        } catch(err) {
                            failure(err, reader.result);
                        }
                    };
                    reader.readAsText(fileFile);
                });
            }, failure);
        },
        findAllVersionsOfGameOnFile: function(game, callback) {
            var versions = [];
            resolveLocalFileSystemURL(cordova.file.dataDirectory + '/content/' + game, function(gameFolder) {
                var reader = gameFolder.createReader();
                reader.readEntries(function(entries) {
                    var version = 0;
                    for (var i=0; i<entries.length; i++) {
                        var entry = entries[i];
                        var nameMatch = /^v_([0-9]+)$/.exec(entry.name);
                        if (entry.isDirectory && nameMatch) {
                            versions.push(parseInt(nameMatch[1]));
                        }
                    }
                    callback(versions);
                }, app.util.error)
            }, function(error) {
                // We haven't downloaded the game yet, so we can rely on the version in the site.json
                callback([]);
            })
        },
        findHighestGameVersionOnFile: function(game, callback, fallback) {
            app.util.findAllVersionsOfGameOnFile(game, function(versions) {
                if (versions.length === 0) {
                    app.gameStates[game].version = fallback;
                } else {
                    app.gameStates[game].version = Math.max.apply(null, versions);
                }
                callback();
            });
        },
        appendHash: function(hashAdd) {
            var hash = app.util.location.hash;
            var split = hash.split(/#|&|%26/).splice(1);
            split.push(hashAdd);
            // Get the unique list of hashes
            split = split.filter(function() {
                var seen = {};
                return function(element, index, array) {
                    return !(element in seen) && (seen[element] = 1);
                };
            }());
            app.util.location.hash = '#' + split.join('&');
        },
        containsHash: function(hash) {
            return app.util.location.hash.indexOf(hash) !== -1;
        },
        // Helper object that we can override (as we cannot override location for jasmine tests).
        location: window.location,
        startInitialServerAndRedirectForFullUI: function() {
            app.util.startServer(function() {
                app.util.appendHash('serverup');
                // Let's see if we already have the files prepared... if so, let's go straight to the correct page.
                // Otherwise, we have to have to use the root file system, prepare the files, then navigate over.
                resolveLocalFileSystemURL(cordova.file.dataDirectory + 'app/allfiles.json', function () {
                    app.util.location.href = 'http://localhost:8080/app/index.html';
                }, function() {
                    // If we're on iOS, then we want to jump over to the correct host
                    if (cordova.platformId === 'ios') {
                        app.util.location.href = 'http://localhost:8080/index.html';
                    } else {
                        // If we're on Android, then stay on the file://... trust me, it's MILES quicker to keep
                        // the page up, rather than try to navigate to localhost:8080/index.html. You get a 20s
                        // penalty on android trying to load the page using the read-only storage via HTTP.
                        app.onDeviceReady();
                    }
                });
            });
        },
        copyAppFiles: function(callback) {
            $('#preapp').css('display', 'inherit');
            app.util.deleteFolder(cordova.file.dataDirectory + 'tmp');
            $.ajax('allfiles.json').done(function (data) {
                if (typeof data === 'string') {
                    data = JSON.parse(data);
                }
                var files = [];
                var source = cordova.platformId === 'ios' ? 'http://localhost:8080' : cordova.file.applicationDirectory + 'www';
                for (var i = 0; i < data.allFiles.length; i++) {
                    files.push([source + data.allFiles[i], cordova.file.dataDirectory + 'app' + data.allFiles[i]]);
                }
                files.push([source + '/allfiles.json', cordova.file.dataDirectory + 'app/allfiles.json']);
                app.download.downloadLocalFiles(files, null, callback, app.util.error);
            });
        },
        createTemporaryFolder: function() {
            resolveLocalFileSystemURL(cordova.file.dataDirectory, function(root) {
                root.getDirectory('tmp', {create: true, exclusive: false});
            });
        },
        displayFullUI: function() {
            app.ads.configureAdColonyAdverts();
            app.ads.configureChartBoost();
            app.util.createTemporaryFolder();
            $.ajax('/app/prebundle.json')
                .done(app.ui.setPrebundleFlagsOnGames)
                .fail(app.ui.getSiteJsonAndUpdateUI);
            app.flurryAnalytics = new FlurryAnalytics();
            app.flurryAnalytics.init(cordova.platformId === 'ios' ? '85TTYPQRNV2XNMKFGP4F' : 'JMXTHPP7TCTY8N67H5P7', function () {
                console.log('Flurry Online');
            }, function (err) {
                console.error(['Flurry Offline', err]);
            });
        },
        error: function() {
            console.error(arguments);
        },
        emptyFunction: function() {},
        queueFunctionToRunAfterCurrentThread: function(fn) {
            setTimeout(fn, 0);
        },
        addCustomGame: function() {
            var gameCode = prompt('Please provide the game code for the game you want to add');
            if (gameCode) {
                var game = {
                    code: gameCode,
                    icon: '/img/logo-65.png'
                };
                $.ajax(app.siteDomain + '/game/' + gameCode + '/details.json').done(function(data) {
                    if (typeof data === 'string') {
                        data = JSON.parse(data);
                    }
                    game.version = data.version;
                    app.gameStates[gameCode] = {version: game.version};
                    var toAppend = app.ui.addGameToBoard(game, false);
                    $(toAppend).find('img').css({width: '100%', height: '100%'});
                    $( '#board' )[0].appendChild(toAppend);
                });
            }
        },
        setSiteDomain: function() {
            var siteDomain = prompt('Please override the site domain', app.siteDomain);
            if (siteDomain) {
                app.siteDomain = siteDomain;
                alert('The site domain for this app has changed to ' + app.siteDomain + '\n Forcing a manual refresh of games list');
                app.siteVersion = 0;
                app.download.checkCurrentSiteVersion();
            }
        },
        online: function() {
            return navigator.connection.type !== 'none';
        }
    };
})();